#ifndef _H_279EFC7FF45A40B7CFC1BDBC7D678CEB_Val_DCPS_H_
#define _H_279EFC7FF45A40B7CFC1BDBC7D678CEB_Val_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Val_.h"


namespace rqt_py_common
{
    namespace msg
    {
        namespace dds_
        {
            class Val_TypeSupportInterface;

            typedef Val_TypeSupportInterface * Val_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Val_TypeSupportInterface> Val_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Val_TypeSupportInterface> Val_TypeSupportInterface_out;


            class Val_DataWriter;

            typedef Val_DataWriter * Val_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Val_DataWriter> Val_DataWriter_var;
            typedef DDS_DCPSInterface_out < Val_DataWriter> Val_DataWriter_out;


            class Val_DataReader;

            typedef Val_DataReader * Val_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Val_DataReader> Val_DataReader_var;
            typedef DDS_DCPSInterface_out < Val_DataReader> Val_DataReader_out;


            class Val_DataReaderView;

            typedef Val_DataReaderView * Val_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Val_DataReaderView> Val_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Val_DataReaderView> Val_DataReaderView_out;

            struct Val_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Val_, struct Val_Seq_uniq_> Val_Seq;
            typedef DDS_DCPSSequence_var < Val_Seq> Val_Seq_var;
            typedef DDS_DCPSSequence_out < Val_Seq> Val_Seq_out;

            class  Val_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Val_TypeSupportInterface_ptr _ptr_type;
                typedef Val_TypeSupportInterface_var _var_type;

                static Val_TypeSupportInterface_ptr _duplicate (Val_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Val_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Val_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Val_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Val_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Val_TypeSupportInterface () {};
                ~Val_TypeSupportInterface () {};
            private:
                Val_TypeSupportInterface (const Val_TypeSupportInterface &);
                Val_TypeSupportInterface & operator = (const Val_TypeSupportInterface &);
            };

            class  Val_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Val_DataWriter_ptr _ptr_type;
                typedef Val_DataWriter_var _var_type;

                static Val_DataWriter_ptr _duplicate (Val_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Val_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Val_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Val_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Val_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Val_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Val_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Val_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Val_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Val_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Val_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Val_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Val_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Val_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Val_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Val_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Val_& instance_data) = 0;

            protected:
                Val_DataWriter () {};
                ~Val_DataWriter () {};
            private:
                Val_DataWriter (const Val_DataWriter &);
                Val_DataWriter & operator = (const Val_DataWriter &);
            };

            class  Val_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Val_DataReader_ptr _ptr_type;
                typedef Val_DataReader_var _var_type;

                static Val_DataReader_ptr _duplicate (Val_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Val_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Val_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Val_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Val_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Val_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Val_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Val_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Val_& instance) = 0;

            protected:
                Val_DataReader () {};
                ~Val_DataReader () {};
            private:
                Val_DataReader (const Val_DataReader &);
                Val_DataReader & operator = (const Val_DataReader &);
            };

            class  Val_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Val_DataReaderView_ptr _ptr_type;
                typedef Val_DataReaderView_var _var_type;

                static Val_DataReaderView_ptr _duplicate (Val_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Val_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Val_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Val_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Val_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Val_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Val_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Val_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Val_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Val_& instance) = 0;

            protected:
                Val_DataReaderView () {};
                ~Val_DataReaderView () {};
            private:
                Val_DataReaderView (const Val_DataReaderView &);
                Val_DataReaderView & operator = (const Val_DataReaderView &);
            };
        }

    }

}

#endif
